<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use App\Http\Handler\SyncHandler;
use App\Http\Models\ItempopenerimaanioModel;
use App\Http\Models\ItempopenerimaanModel;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\LogsyncoracleService;
use App\Http\Services\LogsynckapalService;


use App\Http\Models\AccountModel;
use App\Http\Models\ItemModel;
use App\Http\Models\PopenerimaanModel;
use App\Http\Models\PopenerimaanioModel;
use App\Http\Models\KapalModel;
use App\Http\Models\RolesModel;
use App\Http\Models\UsersModel;
use App\Http\Models\VoyageModel;
use App\Http\Models\LokasiitemModel;
use App\Http\Models\ItemonhandModel;
use App\Http\Models\AdministratormenuModel;
use App\Http\Models\AdministratorgroupaccessModel;
use App\Http\Models\RolelokasiitemModel;
use App\Http\Models\RolecategoryModel;
use App\Http\Models\ItemcategoryModel;
use App\Http\Models\KapallokasiitemModel;
use App\Http\Models\SyncerrorModel;

use App\Http\Models\AdjustmentModel;
use App\Http\Models\AdjustmentLogModel;
use App\Http\Models\SystemparameterModel;

use App\Http\Models\StgpelniscmrcvintModel;
use App\Http\Models\StgpelniscmrcvtrxintModel;
use App\Http\Models\StgpelniprintModel;
use App\Http\Models\StgpelniscmmoiintModel;
use App\Http\Models\StgpelniscmmotintModel;
use App\Http\Models\StgpelniiotintModel;
use App\Http\Models\StgpelniscmmiscrcvintModel;

use \App\Http\Models\SyncUtilities\StagingSyncTableModel;

class ManualsyncController extends BaseController
{
    protected $baseService;
    public $kapalHO;

    /**
     * Item constructor.
     */
    public function __construct(Request $request)
    {
        parent::__construct();

        $auth = json_decode($request->session()->get('auth'));
        if ($auth->aplikasi == "HO") {
            $this->kapalHO = "HO";
            $this->baseService = new LogsyncoracleService();

            $this->data["oracleHO"] = [
                "item" => ["item", "Master Item / Barang"],
                "itemcategory" => ["itemcategory", "Master Item Category"],
                "popenerimaan" => ["popenerimaan", "Transaksi Penerimaan PO"],
                // "itempopenerimaan" => ["itempopenerimaan", "Detail Penerimaan PO"],
                "popenerimaanio" => ["popenerimaanio", "Transaksi Penerimaan IO"],
                // "itempopenerimaanio" => ["itempopenerimaanio", "Detail Penerimaan IO"],
                "kapal" => ["kapal", "Master Kapal"],
                "voyages" => ["voyages", "Master Voyages"],
                "lokasiitem" => ["lokasiitem", "Master Sub-Inventori"],
                "item_onhand" => ["item_onhand", "Master item On-Hand"],
                "sync_error" => ["sync_error", "Sync Errors"]
            ];
            $this->data["hoOracle"] = [
                "pelniscmrcvint" => ["pelniscmrcvint", "Penerimaan Barang PO"],
                "pelniscmrcvtrxint" => ["pelniscmrcvtrxint", "Item Penerimaan Barang PO"],
                "pelniprint" => ["pelniprint", "Permintaan Barang - PR"],
                "pelniscmmoiint" => ["pelniscmmoiint", "Penggunaan Barang"],
                "pelniscmmotint" => ["pelniscmmotint", "Transfer Sub-Inventori"],
                "pelniiotint" => ["pelniiotint", "Transfer/Penerimaan Barang IO"],
                "pelniscmmiscrcvint" => ["pelniscmmiscrcvint", "Penerimaan/Penggunaan Makanan"]
            ];
        } else {
            $this->kapalHO = "Kapal";
            $this->baseService = new LogsynckapalService();

            $this->data["hoKapal"] = [
                //     "account" => ["account", "Account HO to Kapal"],
                "kapal" => ["kapal", "Kapal HO to Kapal"],
                "menus" => ["menus", "Menu HO to Kapal"],
                "users" => ["users", "Users HO to Kapal"],
                "roles" => ["roles", "Roles HO to Kapal"],
                "access" => ["access", "Group Acess HO to Kapal"],
                "lokasiitem" => ["lokasiitem", "Sub-Inventory HO to Kapal"],
                "voyages" =>  ["voyages", "Voyages HO to Kapal"],
                "item_onhand" =>  ["item_onhand", "Item On Hand HO to Kapal"],
                "items" =>  ["items", "Item HO to Kapal"],
                "itemcategory" =>  ["itemcategory", "Item Category HO to Kapal"],
                "popenerimaan" =>  ["popenerimaan", "PO Penerimaan HO to Kapal"],
                "popenerimaanio" =>  ["popenerimaanio", "PO Penerimaan IO HO to Kapal"],
                "systemparameter" =>  ["systemparameter", "System Parameters HO to Kapal"],
                "sync_error" => ["sync_error", "Sync Errors"]
            ];

            $this->data["kapalHO"] = [
                ["permintaanbarang", "Permintaan Barang Kapal to HO"],
                ["itempermintaanbarang_", "Item Permintaan Barang Kapal to HO"],
                ["penerimaanbarang", "Penerimaan Barang Kapal to HO"],
                ["itempenerimaanbarang", "Item Penerimaan Barang Kapal to HO"],
                ["penerimaanbarangio", "Penerimaan Barang IO Kapal to HO"],
                ["itempenerimaanbarangio", "Item Penerimaan Barang IO Kapal to HO"],
                ["pindahbarangio", "Transfer IO Kapal to HO"],
                ["itempindahbarangio", "Item Transfer IO Kapal to HO"],
                ["penggunaanbarang", "Penggunaan Barang Kapal to HO"],
                ["itempenggunaanbarang", "Item Penggunaan Barang Kapal to HO"],
                ["penggunaanmakanan", "Penggunaan Makanan Kapal to HO"],
                ["itempenggunaanmakanan", "Item Penggunaan Makanan Kapal to HO"],
                ["pindahbarangsubinv", "Transfer SubInventory Kapal to HO"],
                ["itempindahbarangsubinv", "Item Transfer SubInventory Kapal to HO"],
                ["penerimaanmakanan", "Penerimaan Makanan Kapal to HO"],
                ["itempenerimaanmakanan", "Item Penerimaan Makanan Kapal to HO"]
            ];
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Http\JsonResponse
     */
    public function paging(Request $request)
    {
        $this->data["title"] = $this->kapalHO;
        if ($this->data["title"] == "HO") {
            foreach ($this->data["hoOracle"] as $idx => $arr) {
                $this->data["hoOracle"][$idx][] = $this->baseService->getLatestUpdate($arr[1]);
            }
            foreach ($this->data["oracleHO"] as $idx => $arr) {
                $this->data["oracleHO"][$idx][] = $this->baseService->getLatestUpdate($arr[1]);
            }
            return view("modules.manualsync.manualsyncho_index", $this->data);
        } else {
            foreach ($this->data["hoKapal"] as $idx => $arr) {
                $this->data["hoKapal"][$idx][] = $this->baseService->getLatestUpdate($arr[1]);
            }
            foreach ($this->data["kapalHO"] as $idx => $arr) {
                $this->data["kapalHO"][$idx][] = $this->baseService->getLatestUpdate($arr[1]);
            }
            return view("modules.manualsync.manualsynckapal_index", $this->data);
        }
    }

    public function syncKapal(Request $request)
    {
        $input =  $request->all();
        $lastestUpdate = "";
        switch ($input["modul"]) {
            case "account":
                ob_start();
                AccountModel::getAccount();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "kapal":
                ob_start();
                KapalModel::getKapal();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "menus":
                ob_start();
                AdministratormenuModel::getMenu();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "users":
                ob_start();
                UsersModel::getUsers();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "roles":
                ob_start();
                RolesModel::getRole();
                RolelokasiitemModel::getRoleLokasiItem();
                RolecategoryModel::getRoleCategory();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "access":
                ob_start();
                AdministratorgroupaccessModel::getMenuAccess();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "lokasiitem":
                ob_start();
                KapalModel::getKapal();
                LokasiitemModel::getLokasiItem();
                KapallokasiitemModel::getKapalLokasiItem();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "voyages":
                ob_start();
                VoyageModel::getVoyages(true);
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "item_onhand":
                ob_start();
                KapalModel::getKapal();
                LokasiitemModel::getLokasiItem();
                KapallokasiitemModel::getKapalLokasiItem();
                AdjustmentModel::getAdjustment(true);
                AdjustmentLogModel::getAdjustmentLog(true);
                ItemonhandModel::getItemOnHand();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "itemcategory":
                ob_start();
                ItemcategoryModel::getItemCategory();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "items":
                ob_start();
                ItemModel::getItem(true);
                ItemcategoryModel::getItemCategory();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "popenerimaan":
                ob_start();
                PopenerimaanModel::getPo(true);
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "popenerimaanio":
                ob_start();
                PopenerimaanioModel::getPOIO(true);
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "systemparameter":
                ob_start();
                SystemparameterModel::getSystemParameter();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "sync_error":
                ob_start();
                SyncerrorModel::syncFromHOKapal(true);
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoKapal"][$input["modul"]][1]);
                break;
            case "kapalHO":
                ob_start();
                $this->sync();
                ob_end_clean();
                foreach ($this->data["kapalHO"] as $idx => $arr) {
                    $this->data["kapalHO"][$idx][] = $this->baseService->getLatestUpdate($arr[1]);
                }
                $lastestUpdate = $this->data["kapalHO"];
                break;
            default:
                break;
        }

        echo json_encode($lastestUpdate);
    }

    public function syncHO(Request $request)
    {
        $input =  $request->all();
        $lastestUpdate = "";

        if (substr($input["modul"], 0, 5) != "pelni") {
            $stag = (new \App\Http\Models\SyncUtilities\StagingSyncTableModel)->where("target_table", "ILIKE", $input["modul"])->first();
        }
        set_time_limit(0);
        ini_set('max_execution_time', 0);
        switch ($input["modul"]) {
            case "kapal":
                ob_start();
                $stag = (new \App\Http\Models\SyncUtilities\StagingSyncTableModel)->where("target_table", "ILIKE", "kapal")->first();
                (new KapalModel())->syncFromOracleHO($stag, true);
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["oracleHO"][$input["modul"]][1]);
                break;
            case "sync_error":
                ob_start();
                (new SyncerrorModel())->syncFromOracleHO(true);
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["oracleHO"][$input["modul"]][1]);
                break;
            case "lokasiitem":
                ob_start();
                $stag = (new \App\Http\Models\SyncUtilities\StagingSyncTableModel)->where("target_table", "ILIKE", "kapal")->first();
                (new KapalModel())->syncFromOracleHO($stag, true);
                $stag = (new \App\Http\Models\SyncUtilities\StagingSyncTableModel)->where("target_table", "ILIKE", "lokasiitem")->first();
                (new LokasiitemModel())->syncFromOracleHO($stag, true);
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["oracleHO"][$input["modul"]][1]);
                break;
            case "voyages":
                ob_start();
                (new VoyageModel())->syncFromOracleHO($stag, true);
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["oracleHO"][$input["modul"]][1]);
                break;
            case "item_onhand":
                ob_start();
                $stag = (new \App\Http\Models\SyncUtilities\StagingSyncTableModel)->where("target_table", "ILIKE", "pelni_scm_adj_trx_v")->first();
                (new AdjustmentModel())->syncFromOracleHO($stag, true);
                $stag = (new \App\Http\Models\SyncUtilities\StagingSyncTableModel)->where("target_table", "ILIKE", "pelni_scm_others_trx_v")->first();
                (new AdjustmentLogModel())->syncFromOracleHO($stag, true);
                $stag = (new \App\Http\Models\SyncUtilities\StagingSyncTableModel)->where("target_table", "ILIKE", "item_onhand")->first();
                (new ItemonhandModel())->syncFromOracleHO($stag);
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["oracleHO"][$input["modul"]][1]);
                break;
            case "item":
                ob_start();
                (new ItemModel())->syncFromOracleHO($stag, true);
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["oracleHO"][$input["modul"]][1]);
                break;
            case "itemcategory":
                ob_start();
                (new ItemcategoryModel())->syncFromOracleHO($stag);
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["oracleHO"][$input["modul"]][1]);
                break;
            case "popenerimaan":
                ob_start();
                (new PopenerimaanModel())->syncFromOracleHO($stag, true);
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["oracleHO"][$input["modul"]][1]);
                break;
            case "popenerimaanio":
                ob_start();
                (new PopenerimaanioModel())->syncFromOracleHO($stag, true);
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["oracleHO"][$input["modul"]][1]);
                break;

            case "pelniscmrcvint":
                ob_start();
                (new StgpelniscmrcvintModel())->prepareSaveToOracle();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoOracle"][$input["modul"]][1]);
                break;
            case "pelniscmrcvtrxint":
                ob_start();
                (new StgpelniscmrcvtrxintModel())->prepareSaveToOracle();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoOracle"][$input["modul"]][1]);
                break;
            case "pelniprint":
                ob_start();
                (new StgpelniprintModel())->prepareSaveToOracle();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoOracle"][$input["modul"]][1]);
                break;
            case "pelniscmmoiint":
                ob_start();
                (new StgpelniscmrcvintModel())->prepareSaveToOracle();
                (new StgpelniscmrcvtrxintModel())->prepareSaveToOracle();
                (new StgpelniscmmoiintModel())->prepareSaveToOracle();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoOracle"][$input["modul"]][1]);
                break;
            case "pelniscmmotint":
                ob_start();
                (new StgpelniscmmotintModel())->prepareSaveToOracle();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoOracle"][$input["modul"]][1]);
                break;
            case "pelniiotint":
                ob_start();
                (new StgpelniiotintModel())->prepareSaveToOracle();
                ob_end_clean();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoOracle"][$input["modul"]][1]);
                break;
            case "pelniscmmiscrcvint":
                ob_start();
                (new StgpelniscmmiscrcvintModel())->prepareSaveToOracle();
                $lastestUpdate = $this->baseService->getLatestUpdate($this->data["hoOracle"][$input["modul"]][1]);
                break;
            case "hoOracle":
                ob_start();
                (new StgpelniprintModel())->prepareSaveToOracle();
                (new StgpelniscmrcvintModel())->prepareSaveToOracle();
                (new StgpelniscmrcvtrxintModel())->prepareSaveToOracle();
                (new StgpelniscmmoiintModel())->prepareSaveToOracle();
                (new StgpelniscmmotintModel())->prepareSaveToOracle();
                (new StgpelniiotintModel())->prepareSaveToOracle();
                (new StgpelniscmmiscrcvintModel())->prepareSaveToOracle();
                ob_end_clean();

                foreach ($this->data["hoOracle"] as $idx => $arr) {
                    $this->data["hoOracle"][$idx][] = "2018-12-26 14:01:00"; // $this->baseService->getLatestUpdate($arr[1]);
                }
                $lastestUpdate = $this->data["hoOracle"];
                break;

            default:
                break;
        }

        echo json_encode($lastestUpdate);
    }
}
